// Code generated by Kitex v1.9.1. DO NOT EDIT.

package studentservice

import (
	"code.byted.org/kite/kitex/client"
	kitex "code.byted.org/kite/kitex/pkg/serviceinfo"
	"code.byted.org/kitex/example_student/kitex_gen/kitex/example/student"
	"context"
)

func serviceInfo() *kitex.ServiceInfo {
	return studentServiceServiceInfo
}

var studentServiceServiceInfo = newServiceInfo()

func newServiceInfo() *kitex.ServiceInfo {
	serviceName := "StudentService"
	handlerType := (*student.StudentService)(nil)
	methods := map[string]kitex.MethodInfo{
		"GetStudentById":    kitex.NewMethodInfo(getStudentByIdHandler, newStudentServiceGetStudentByIdArgs, newStudentServiceGetStudentByIdResult, false),
		"InsertStudent":     kitex.NewMethodInfo(insertStudentHandler, newStudentServiceInsertStudentArgs, newStudentServiceInsertStudentResult, false),
		"UpdateStudent":     kitex.NewMethodInfo(updateStudentHandler, newStudentServiceUpdateStudentArgs, newStudentServiceUpdateStudentResult, false),
		"DeleteStudentById": kitex.NewMethodInfo(deleteStudentByIdHandler, newStudentServiceDeleteStudentByIdArgs, newStudentServiceDeleteStudentByIdResult, false),
	}
	extra := map[string]interface{}{
		"PackageName": "student",
	}
	svcInfo := &kitex.ServiceInfo{
		ServiceName:     serviceName,
		HandlerType:     handlerType,
		Methods:         methods,
		PayloadCodec:    kitex.Thrift,
		KiteXGenVersion: "v1.9.1",
		Extra:           extra,
	}
	return svcInfo
}

func getStudentByIdHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	realArg := arg.(*student.StudentServiceGetStudentByIdArgs)
	realResult := result.(*student.StudentServiceGetStudentByIdResult)
	success, err := handler.(student.StudentService).GetStudentById(ctx, realArg.Req)
	if err != nil {
		return err
	}
	realResult.Success = success
	return nil
}
func newStudentServiceGetStudentByIdArgs() interface{} {
	return student.NewStudentServiceGetStudentByIdArgs()
}

func newStudentServiceGetStudentByIdResult() interface{} {
	return student.NewStudentServiceGetStudentByIdResult()
}

func insertStudentHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	realArg := arg.(*student.StudentServiceInsertStudentArgs)
	realResult := result.(*student.StudentServiceInsertStudentResult)
	success, err := handler.(student.StudentService).InsertStudent(ctx, realArg.Req)
	if err != nil {
		return err
	}
	realResult.Success = success
	return nil
}
func newStudentServiceInsertStudentArgs() interface{} {
	return student.NewStudentServiceInsertStudentArgs()
}

func newStudentServiceInsertStudentResult() interface{} {
	return student.NewStudentServiceInsertStudentResult()
}

func updateStudentHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	realArg := arg.(*student.StudentServiceUpdateStudentArgs)
	realResult := result.(*student.StudentServiceUpdateStudentResult)
	success, err := handler.(student.StudentService).UpdateStudent(ctx, realArg.Req)
	if err != nil {
		return err
	}
	realResult.Success = success
	return nil
}
func newStudentServiceUpdateStudentArgs() interface{} {
	return student.NewStudentServiceUpdateStudentArgs()
}

func newStudentServiceUpdateStudentResult() interface{} {
	return student.NewStudentServiceUpdateStudentResult()
}

func deleteStudentByIdHandler(ctx context.Context, handler interface{}, arg, result interface{}) error {
	realArg := arg.(*student.StudentServiceDeleteStudentByIdArgs)
	realResult := result.(*student.StudentServiceDeleteStudentByIdResult)
	success, err := handler.(student.StudentService).DeleteStudentById(ctx, realArg.Req)
	if err != nil {
		return err
	}
	realResult.Success = success
	return nil
}
func newStudentServiceDeleteStudentByIdArgs() interface{} {
	return student.NewStudentServiceDeleteStudentByIdArgs()
}

func newStudentServiceDeleteStudentByIdResult() interface{} {
	return student.NewStudentServiceDeleteStudentByIdResult()
}

type kClient struct {
	c client.Client
}

func newServiceClient(c client.Client) *kClient {
	return &kClient{
		c: c,
	}
}

func (p *kClient) GetStudentById(ctx context.Context, req *student.GetStudentByIdRequest) (r *student.GetStudentByIdResponse, err error) {
	var _args student.StudentServiceGetStudentByIdArgs
	_args.Req = req
	var _result student.StudentServiceGetStudentByIdResult
	if err = p.c.Call(ctx, "GetStudentById", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) InsertStudent(ctx context.Context, req *student.InsertStudentRequest) (r *student.InsertStudentResponse, err error) {
	var _args student.StudentServiceInsertStudentArgs
	_args.Req = req
	var _result student.StudentServiceInsertStudentResult
	if err = p.c.Call(ctx, "InsertStudent", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) UpdateStudent(ctx context.Context, req *student.UpdateStudentRequest) (r *student.UpdateStudentResponse, err error) {
	var _args student.StudentServiceUpdateStudentArgs
	_args.Req = req
	var _result student.StudentServiceUpdateStudentResult
	if err = p.c.Call(ctx, "UpdateStudent", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}

func (p *kClient) DeleteStudentById(ctx context.Context, req *student.DeleteStudentByIdRequest) (r *student.DeleteStudentByIdResponse, err error) {
	var _args student.StudentServiceDeleteStudentByIdArgs
	_args.Req = req
	var _result student.StudentServiceDeleteStudentByIdResult
	if err = p.c.Call(ctx, "DeleteStudentById", &_args, &_result); err != nil {
		return
	}
	return _result.GetSuccess(), nil
}
